package signup;

import java.util.HashMap;

import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.PageFlowController;
import org.apache.beehive.netui.pageflow.annotations.Jpf;

@Jpf.Controller
public class Controller extends PageFlowController {
    public HashMap questionMap = new HashMap();

    protected void onCreate() {
        questionMap.put("vacation", "ιˤǤʤ");
        questionMap.put("color", "ʤ");
        questionMap.put("music", "ڤʤ");
    }

    @Jpf.Action(
        forwards={
            @Jpf.Forward(name="signup", path="/signup/index.jsp",
                actionOutputs = {
                    @Jpf.ActionOutput(name="questionMap",
                                      type=java.util.HashMap.class,
                                      required=true)
                }
            )
        }
    )
    public Forward begin() {
        Forward forward = new Forward("signup");
        forward.addActionOutput("questionMap", questionMap);
        return forward;
    }

    @Jpf.Action(
        forwards={
            @Jpf.Forward(name="signup_success", path="/login.jsp"),
            @Jpf.Forward(name="signup_failure", path="fail.jsp")
        },
        validatableProperties={
            @Jpf.ValidatableProperty(
                propertyName="email",
                displayName="Email address",
                validateRequired=@Jpf.ValidateRequired(),
                validateEmail=@Jpf.ValidateEmail()
            ),
            @Jpf.ValidatableProperty(
                propertyName="username",
                displayName="Username",
                validateRequired=@Jpf.ValidateRequired(),
                validateMinLength=@Jpf.ValidateMinLength(chars = 4)
            ),
            @Jpf.ValidatableProperty(
                propertyName="password",
                displayName="Password",
                validateRequired=@Jpf.ValidateRequired(),
                validateMinLength=@Jpf.ValidateMinLength(chars = 6)
            )
        },
        validationErrorForward=
            @Jpf.Forward(
                name="signup_failure", path="fail.jsp"
            )
    )
    public Forward processSignup(SignupForm form) {
        String email = form.getEmail();
        String username = form.getUsername();
        String password = form.getPassword();
        String confirm = form.getConfirm();
        String question = form.getQuestion();
        String answer = form.getAnswer();
        if ((confirm != null) && (!password.equals(confirm))) {
            return new Forward("signup_failure");
        }
        return new Forward("signup_success");
    }

    public static class SignupForm {
        private String email;
        private String username;
        private String password;
        private String confirm;
        private String question;
        private String answer;

		public String getAnswer() {
			return answer;
		}

		public void setAnswer(String answer) {
			this.answer = answer;
		}
		
		public String getConfirm() {
			return confirm;
		}

		public void setConfirm(String confirm) {
			this.confirm = confirm;
		}

		public String getEmail() {
			return email;
		}
		
		public void setEmail(String email) {
			this.email = email;
		}
		
		public String getPassword() {
			return password;
		}
		
		public void setPassword(String password) {
			this.password = password;
		}
		
		public String getQuestion() {
			return question;
		}
		
		public void setQuestion(String question) {
			this.question = question;
		}

		public String getUsername() {
			return username;
		}

		public void setUsername(String username) {
			this.username = username;
		}
    }
}